// Author: Vahe Mamyan
// -------------------------------------------------------------------

#ifndef TSHMSMaterialManager_hh
#define TSHMSMaterialManager_hh

#include <vector>
#include <map>
#include "G4ThreeVector.hh"
#include "G4Material.hh"
#include "G4OpticalSurface.hh"

//-----------------------------------------------------------------------------
#include <fstream>

class TSHMSMaterialManager
{
public:
  virtual ~TSHMSMaterialManager();

  // method to call to create an instance of this class
  static TSHMSMaterialManager* getInstance();

  void  print() { G4cout << " Material Manager" << G4endl; }
  void  BuildMaterials();
  G4Material*        FindMaterial( const G4String name )      { return TSHMSMaterialManager::fMaterialMap[name]; }
  G4OpticalSurface*  FindOpticalSurface( const G4String name ) { return TSHMSMaterialManager::fOpticalSurfaceMap[name]; }
private:
  //private constructor in order to create a singleton
  
  TSHMSMaterialManager();
  static TSHMSMaterialManager*   instance;

  std::map<G4String,G4Material*> fMaterialMap;
  std::map<G4String,G4OpticalSurface*> fOpticalSurfaceMap;
};

#endif
